package com.malk.lingmingguangzi.controller;

import com.malk.lingmingguangzi.service.LingmingguangziService;
import com.malk.server.common.McR;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RestController;

import java.util.Map;
import java.util.Objects;

@RestController
@Slf4j
public class LingmingguangziController {
    @Autowired
    private LingmingguangziService lingmingguangziService;

    @GetMapping("/test")
    public McR test() {
        return lingmingguangziService.test();
    }

    /**
     * 获取车载客户回收问卷数量
     */
    @GetMapping("/getCustomerQuestionnaireCount")
    public McR getVehicleCustomerCount(Long start, Long end) {
        return lingmingguangziService.getCustomerQuestionnaireCount(start, end);
    }

    /**
     * 获取消费客户回收问卷列表
     * @param start
     * @param end
     * @return
     */
    @GetMapping("/getCustomerQuestionnaireCount2")
    public McR getCustomerQuestionnaireCount2(Long start, Long end) {
        return lingmingguangziService.getCustomerQuestionnaireCount2(start, end);
    }

    /**
     * 获取tb转阶段申请交付件等详情
     * @param stageName
     * @return
     */
    @GetMapping("/getTbStageDetails")
    public McR getTbStageDetails(String projectName,String stageName) {
        return lingmingguangziService.getTbStageDetails(projectName,stageName);
    }

    /**
     * 新增客户
     * @param map
     * @return
     */
    @PostMapping("/addCustomer")
    public McR addCustomer(@RequestBody Map map) {
        return lingmingguangziService.addCustomer(map);
    }

    /**
     * 更新客户
     * @param map
     * @return
     */
    @PostMapping("/updateCustomer")
    public McR updateCustomer(@RequestBody Map map) {
        return lingmingguangziService.updateCustomer(map);
    }

    /**
     * 获取产品交付状态
     * @param keyword
     * @param pageNo
     * @param pageSize
     * @return
     */
    @GetMapping("/getProductDeliveryStatus")
    public McR getProductDeliveryStatus(String keyword,int pageNo,int pageSize) {
        return lingmingguangziService.getProductDeliveryStatus(keyword,pageNo,pageSize);
    }

    /**
     * 获取工序
     * @return
     */
    @GetMapping("/getProcess")
    public McR getProcess(int pageNo,int pageSize) {
        return lingmingguangziService.getProcess(pageNo,pageSize);
    }

    /**
     * 获取税率
     * @return
     */
    @GetMapping("/getTaxRate")
    public McR getTaxRate() {
        return lingmingguangziService.getTaxRate();
    }

    /**
     * 新增销售订单
     * @param map
     * @return
     */
    @PostMapping("/addSaleOrder")
    public McR addSaleOrder(@RequestBody Map map) {
        return lingmingguangziService.addSaleOrder(map);
    }

    /**
     * 更新销售订单
     * @param map
     * @return
     */
    @PostMapping("/updateSaleOrder")
    public McR updateSaleOrder(@RequestBody Map map) {
        return lingmingguangziService.updateSaleOrder(map);
    }

    //todo 定时更新工序

    //todo 定时更新币别

    //todo 定时更新税率
}
